﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using Telerik.Windows.Controls;
using Telerik.Windows.Diagrams.Core;
using Telerik.Windows.DragDrop;

namespace Diagram_WPF_ListBoxDrop
{
    public partial class MainWindow : Window
    {
        ISerializationService service;
        public MainWindow()
        {
            InitializeComponent();
            DragDropManager.AddDragInitializeHandler(xListBox, OnDragInitialize);
            service = xDiagram.ServiceLocator.GetService<ISerializationService>();
        }

        private void OnDragInitialize(object sender, DragInitializeEventArgs args)
        {
            args.AllowedEffects = DragDropEffects.All;
            SerializationInfo serializaedInfo;
            if (args.OriginalSource is RadDiagramShape)
            {
                RadDiagramShape draggedShape = args.OriginalSource as RadDiagramShape;
                List<RadDiagramShape> shapes = new List<RadDiagramShape>();
                shapes.Add(draggedShape);
                serializaedInfo = SerializationService.Default.SerializeItems(shapes);

            }
            else
            {
                RadDiagramContainerShape draggedShape = args.OriginalSource as RadDiagramContainerShape;
                List<RadDiagramContainerShape> shapes = new List<RadDiagramContainerShape>();
                shapes.Add(draggedShape);
                serializaedInfo = SerializationService.Default.SerializeItems(shapes);

            }
            args.Data = serializaedInfo;
        }
    }
}